package com.ejie.ab79.dao.AB63;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.AB63.Categorias;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * CategoriasDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class CategoriasDaoImpl implements CategoriasDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDCATEGORIAS", "IDTIPOESTABLECIMIENTO",
			"DESCRIPCIONCASTELLANO", "BAJA", "DESCRIPCIONEUSKERA" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Categorias> rwMap = new RowMapper<Categorias>() {
		public Categorias mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Categorias(resultSet.getString("IDCATEGORIAS"), resultSet.getString("IDTIPOESTABLECIMIENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getInt("BAJA"), resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public List<Categorias> findAll(Categorias categorias, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, "
				+ " t1.BAJA BAJA,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM CATEGORIAS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(categorias);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, CategoriasDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	
	private Map<String, ?> getWhereMap(Categorias categorias) {

		StringBuilder where = new StringBuilder(CategoriasDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (categorias != null && categorias.getIdCategorias() != null) {
			where.append(" AND t1.ID_CATEGORIAS = ?");
			params.add(categorias.getIdCategorias());
		}
		if (categorias != null && categorias.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(categorias.getIdTipoEstablecimiento());
		}
		if (categorias != null && categorias.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(categorias.getDescripcionCastellano());
		}
		if (categorias != null && categorias.getBaja() != null) {
			where.append(" AND t1.BAJA = ?");
			params.add(categorias.getBaja());
		}
		if (categorias != null && categorias.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(categorias.getDescripcionEuskera());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
